PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Protected Member Functions | List of all members
POrdinalDictionary< K > Class Template Reference

This template class maps the `PAbstractDictionary` to a specific key type and a `POrdinalKey` data type. More...

`#include <dict.h>`

Inheritance diagram for POrdinalDictionary< K >:
[legend]
Collaboration diagram for POrdinalDictionary< K >:
[legend]

## Public Member Functions
Construction
| POrdinalDictionary ()
| Create a new, empty, dictionary. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the dictionary. More...
New functions for class
PINDEX | operator[] (const K &key) const
| Get the object contained in the dictionary at the `key` position. More...
virtual PBoolean | SetDataAt (PINDEX index, PINDEX ordinal)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PBoolean | SetAt (const K &key, PINDEX ordinal)
| Add a new object to the collection. More...
const K & | GetKeyAt (PINDEX index) const
| Get the key in the dictionary at the ordinal index position. More...
PINDEX | GetDataAt (PINDEX index) const
| Get the data in the dictionary at the ordinal index position. More...
Public Member Functions inherited from PDictionary< K, POrdinalKey >
| PDictionary ()
| Create a new, empty, dictionary. More...
const POrdinalKey & | operator[] (const K &key) const
| Get the object contained in the dictionary at the `key` position. More...
POrdinalKey & | operator[] (const K &key)
PBoolean | Contains (const K &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual POrdinalKey * | RemoveAt (const K &key)
| Remove an object at the specified `key`. More...
virtual PBoolean | SetAt (const K &key, POrdinalKey *obj)
| Add a new object to the collection. More...
virtual POrdinalKey * | GetAt (const K &key) const
| Get the object at the specified key position. More...
const K & | GetKeyAt (PINDEX index) const
| Get the key in the dictionary at the ordinal index position. More...
POrdinalKey & | GetDataAt (PINDEX index) const
| Get the data in the dictionary at the ordinal index position. More...
PArray< K > | GetKeys () const
| Get an array containing all the keys for the dictionary. More...
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
iterator | find (const K &key)
const_iterator | find (const K &k) const
void | erase (const iterator &it)
void | erase (const const_iterator &it)
Public Member Functions inherited from PAbstractDictionary
PINLINE | PAbstractDictionary ()
| Create a new, empty, dictionary. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual PINDEX | Insert (const PObject &key, PObject *obj)
| Insert a new object into the dictionary. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified index. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified index to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified index position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
virtual P_DEPRECATED PBoolean | SetDataAt (PINDEX index, PObject *obj)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PObject * | AbstractSetAt (const PObject &key, PObject *obj)
| Add a new object to the collection. More...
virtual PObject & | GetRefAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual PObject * | AbstractGetAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual void | AbstractGetKeys (PArrayObjects &keys) const
| Get an array containing all the keys for the dictionary. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| POrdinalDictionary (int dummy, const POrdinalDictionary *c)
Protected Member Functions inherited from PDictionary< K, POrdinalKey >
| PDictionary (int dummy, const PDictionary *c)
Protected Member Functions inherited from PAbstractDictionary
PINLINE | PAbstractDictionary (int dummy, const PAbstractDictionary *c)

## Additional Inherited Members
Public Types inherited from PDictionary< K, POrdinalKey >
typedef K | key_type
typedef POrdinalKey | data_type
typedef PDictionary< K, POrdinalKey > | dict_type
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Attributes inherited from PContainer
PContainerReference * | reference
Friends inherited from PObject

## Detailed Description

### template<class K>
class POrdinalDictionary< K >

This template class maps the `PAbstractDictionary` to a specific key type and a `POrdinalKey` data type.

The functions in this class primarily do all the appropriate casting of types.

Note that if templates are not used the `PDECLARE_ORDINAL_DICTIONARY` macro will simulate the template instantiation.

## Constructor & Destructor Documentation

template<class K >

POrdinalDictionary< K >::POrdinalDictionary | ( |  | ) |
| inline

Create a new, empty, dictionary.

Note that by default, objects placed into the dictionary will be deleted when removed or when all references to the dictionary are destroyed.

Referenced by POrdinalDictionary< K >::Clone().

template<class K >

POrdinalDictionary< K >::POrdinalDictionary | ( | int | dummy,
|  | const POrdinalDictionary< K > * | c
| ) |  |
| inline protected

## Member Function Documentation

template<class K >

virtual PObject* POrdinalDictionary< K >::Clone | ( |  | ) | const
| inline virtual

Make a complete duplicate of the dictionary.

Note that all objects in the array are also cloned, so this will make a complete copy of the dictionary.

Reimplemented from PDictionary< K, POrdinalKey >.

References PNEW, and POrdinalDictionary< K >::POrdinalDictionary().

template<class K >

PINDEX POrdinalDictionary< K >::GetDataAt | ( | PINDEX | index | ) | const
| inline

Get the data in the dictionary at the ordinal index position.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

The last key/data pair is remembered by the class so that subseqent access is very fast.

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  reference to data at the index position.

Parameters

  index | Ordinal position in dictionary for data.

References PHashTable::AbstractGetDataAt().

template<class K >

const K& POrdinalDictionary< K >::GetKeyAt | ( | PINDEX | index | ) | const
| inline

Get the key in the dictionary at the ordinal index position.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  reference to key at the index position.

Parameters

  index | Ordinal position in dictionary for key.

References PHashTable::AbstractGetKeyAt().

template<class K >

PINDEX POrdinalDictionary< K >::operator[] | ( | const K & | key | ) | const
| inline

Get the object contained in the dictionary at the `key` position.

The hash table is used to locate the data quickly via the hash function provided by the key.

The last key/data pair is remembered by the class so that subseqent access is very fast.

Returns
  reference to the object indexed by the key.

References PAbstractDictionary::GetRefAt().

template<class K >

virtual PBoolean POrdinalDictionary< K >::SetAt | ( | const K & | key,
|  | PINDEX | ordinal
| ) |  |
| inline virtual

Add a new object to the collection.

If the objects value is already in the dictionary then the object is overrides the previous value. If the `AllowDeleteObjects` option is set then the old object is also deleted.

The object is placed in the an ordinal position dependent on the keys hash function. Subsequent searches use the hash function to speed access to the data item.

Returns
  true if the object was successfully added.

Parameters

  key | Key for position in dictionary to add object.
  ordinal | New ordinal value to put into the dictionary.

References PAbstractDictionary::AbstractSetAt(), and PNEW.

template<class K >

virtual PBoolean POrdinalDictionary< K >::SetDataAt | ( | PINDEX | index,
|  | PINDEX | ordinal
| ) |  |
| inline virtual

Set the data at the specified ordinal index position in the dictionary.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  true if the new object could be placed into the dictionary.

Parameters

  index | Ordinal index in the dictionary.
  ordinal | New ordinal value to put into the dictionary.

References PHashTable::AbstractGetKeyAt(), PAbstractDictionary::AbstractSetAt(), and PNEW.

The documentation for this class was generated from the following file:

- dict.h